﻿Type=Class
Version=5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private SlideForm As Form
	Private SlideTimer As Timer
	Private mMainForm As Form
	Private SlideMove As Int = 10
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(MainForm As Form,Width As Int,Height As Int,Title As String,Layout As String)
	mMainForm = MainForm
	SlideForm.Initialize("SF",Width,Height)
	SlideTimer.Initialize("SlideTimer",20)
	If Layout <> "" Then SlideForm.RootPane.LoadLayout(Layout)
	SlideForm.Title = Title				'Or set the title in the designer and remove the title parameter
	'Set property listeners to enable positioning of sub window
	Dim JO As JavaObject = MainForm.RootPane
	JO = JO.RunMethodJO("getScene",Null).RunMethod("getWindow",Null)
	Dim Listener As Object = JO.CreateEventFromUI("javafx.beans.value.ChangeListener","PropertyChanged",Null)
	JO.RunMethodJO("xProperty",Null).RunMethod("addListener",Array(Listener))
	Dim Listener As Object = JO.CreateEventFromUI("javafx.beans.value.ChangeListener","PropertyChanged",Null)
	JO.RunMethodJO("yProperty",Null).RunMethod("addListener",Array(Listener))
End Sub

'Position sub window if mainForm window is moved
Sub PropertyChanged_Event(MethodName As String,Args() As Object) As Object					'Ignore
	If SlideForm.Visible Then
		SlideForm.WindowLeft =mMainForm.WindowLeft + mMainForm.WindowWidth + SlideMove
		SlideForm.WindowTop = mMainForm.WindowTop + (mMainForm.WindowHeight - SlideForm.WindowHeight) / 2
	End If
End Sub

Public Sub Show
	SlideForm.Show
	SlideForm.WindowLeft = mMainForm.WindowLeft + mMainForm.WindowWidth - SlideForm.WindowWidth
	SlideForm.WindowTop = mMainForm.WindowTop + (mMainForm.WindowHeight - SlideForm.WindowHeight) / 2
	SlideMove = 10
	SlideTimer.Enabled = True
End Sub

Public Sub Hide
	SlideMove = -10
	SlideTimer.Enabled = True
End Sub

Public Sub Close
	SlideForm.Close
End Sub

Sub btnClose_Action
	Hide
End Sub

Sub SlideTimer_Tick
	SlideForm.WindowLeft = SlideForm.WindowLeft + SlideMove
	If SlideForm.WindowLeft + SlideForm.WindowWidth < mMainForm.WindowLeft + mMainForm.WindowWidth Then
		SlideTimer.Enabled = False
		SlideForm.Close
	Else If SlideForm.WindowLeft + SlideMove >= mMainForm.WindowLeft + mMainForm.WindowWidth Then
		SlideTimer.Enabled = False
	End If
End Sub